SystemOrganization addCategory: #MetaTalk!

TestCase subclass: #MetaTalkTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

TestCase subclass: #StackMachineTest
	instanceVariableNames: 'SM'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!StackMachineTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:29'!
setUp

	SM := StackMachine.
	SM clear.! !

!StackMachineTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:50'!
testAt

	SM new.
	SM push: 3.
	self assert: (SM at: 1) = 3.
	! !

!StackMachineTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:50'!
testAtPut

	SM new.
	SM push: 3.
	self assert: (SM at: 1) = 3.
	SM at: 1 put: 10.
	self assert: (SM at: 1) = 10.
	! !

!StackMachineTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 13:08'!
testBlockSendWithReturn! !

!StackMachineTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 15:22'!
testMessageSend

	"3.0 + 4 / 5"

	SM new.
	SM push: (ObjectNumberRepresentation new hostNumberRepresentation: 3.0).
	SM push: (ObjectNumberRepresentation new hostNumberRepresentation: 4).
	PrimitiveCall numberAdd.
	SM push: (ObjectNumberRepresentation new hostNumberRepresentation: 5).
	PrimitiveCall numberDiv.
	self assert: (SM pop hostNumberRepresentation = 1.4)
	! !

!StackMachineTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 15:29'!
testMessageSendWithReturn

	SM new.
	SM push: (ObjectNumberRepresentation new hostNumberRepresentation: 3.0).
	SM push: (ObjectNumberRepresentation new hostNumberRepresentation: 4).
	SM new.
	SM push: SM prev pop.
	SM push: SM prev pop.
	PrimitiveCall numberAdd.
	SM prev push: SM pop.
	SM remove.
	SM push: (ObjectNumberRepresentation new hostNumberRepresentation: 5).
	PrimitiveCall numberDiv.
	self assert: (SM pop hostNumberRepresentation = 1.4)
	! !

!StackMachineTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:46'!
testNew

	self assert: (SM new class = StackMachine).! !

TestCase subclass: #SymbolTableTest
	instanceVariableNames: 'ST'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!SymbolTableTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2011 13:21'!
setUp

	ST := SymbolTable.
	ST clear.! !

!SymbolTableTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2011 13:20'!
testSearch

	|entry|

	SymbolTable new.
	SymbolTable add: (SymbolTableEntry new name: 'Object').
	SymbolTable new.
	SymbolTable add: (SymbolTableEntry new name: 'Class').
	entry := SymbolTable search: 'Object'.
	self assert: (entry offset = -1).
	self assert: (entry genReadCode =  ' (SM  stackAt: -1) at: 1').
	! !

!SymbolTableTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2011 13:04'!
testSearchMethod

	|entry|

	SymbolTable new.
	SymbolTable add: (SymbolTableEntry new name: 'Object').
	SymbolTable addMethod: (SymbolMethodEntry new name: 'at:put').
	SymbolTable new.
	SymbolTable add: (SymbolTableEntry new name: 'Class').
	entry := SymbolTable search: 'Object'.
	self assert: (entry offset = -1).
	self assert: (entry genReadCode =  ' (SM  stackAt: -1) at: 1').
	entry := SymbolTable searchMethod: 'at:put'.
	self assert: (entry index = 1).
	! !

PPCompositeParser subclass: #MetaTalkGrammar
	instanceVariableNames: 'identifier keyword string number messageSend unaryMessage binaryMessage keywordMessage binarySelector expression precedenceExp statement baseExpr varAssignment varDeclaration methodDeclaration classDeclaration blockClosure list methodClosure argument dict returnStatement char primitive'
	classVariableNames: 'arguments depth ivs message superName'
	poolDictionaries: ''
	category: 'MetaTalk'!

!MetaTalkGrammar class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/19/2011 14:00'!
flatten: aCollection

	|flatCollection|
	
	flatCollection := OrderedCollection new.
	(aCollection isCollection & aCollection isString not) ifTrue: [
		aCollection do: [:item | 
			(item isCollection & item isString not) ifTrue: [
				flatCollection addAll: (self flatten: item).
			] ifFalse: [
				flatCollection add: item.
			].
		].
		^ flatCollection.
	] ifFalse: [
		^ aCollection.
	] ! !

!MetaTalkGrammar class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2011 11:50'!
parse: aString

	"initialise SymbolTable and then parse".
	
	SymbolTable clear.
	SymbolTable new.
	SymbolTable add: (SymbolLocalVarEntry new name: 'nil').
	SymbolTable add: (SymbolLocalVarEntry new name: 'true').
	SymbolTable add: (SymbolLocalVarEntry new name: 'false').
	SymbolTable add: (SymbolClassEntry new name: 'Object').
	SymbolTable add: (SymbolClassEntry new name: 'Class').
	SymbolTable add: (SymbolClassEntry new name: 'Block').
	SymbolTable add: (SymbolClassEntry new name: 'Method').
	SymbolTable add: (SymbolClassEntry new name: 'UndefinedObject').
	SymbolTable add: (SymbolClassEntry new name: 'Number').
	SymbolTable add: (SymbolClassEntry new name: 'Char').
	SymbolTable add: (SymbolClassEntry new name: 'Boolean').
	SymbolTable add: (SymbolClassEntry new name: 'True').
	SymbolTable add: (SymbolClassEntry new name: 'False').
	SymbolTable add: (SymbolClassEntry new name: 'List').
	SymbolTable add: (SymbolClassEntry new name: 'String').
	SymbolTable add: (SymbolClassEntry new name: 'Dict').
	^ super parse: aString.! !

!MetaTalkGrammar methodsFor: 'tokens' stamp: 'NickPapoulias 5/17/2011 23:57'!
argument

	^ ($: asParser, (#word asParser plus) flatten) trim ==> [:nodes | nodes at: 2].! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/30/2011 14:06'!
baseExpr 

	^ ( (identifier ==> [:value | 
		(value = 'super') ifFalse: [
			{'StackMachine push: ' , (SymbolTable search: value) genReadCode.} asOrderedCollection
		]
		ifTrue: [
			{'StackMachine push: ' , (SymbolTable search: 'self') genReadCode. 'StackMachine push: ' , (SymbolTable search: value) genReadCode. 'PrimitiveCall superSend'.}	
		]
		]) / 
	number / 
	char /  
	string / 
	list / 
	dict / 
	blockClosure / 
	precedenceExp) ==> [:node | node asOrderedCollection]! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/23/2011 14:21'!
binaryMessage

	^ ((unaryMessage / baseExpr) , (binarySelector , (unaryMessage / baseExpr)) plus) ==> [:nodes | 		
		|code messages argsCode initialReceiverCode methodIndexes|
		messages := (nodes at: 2) collect: [:n | n at: 1].
		argsCode := ((nodes at: 2) collect: [:n | n at: 2]) reversed.
		initialReceiverCode := nodes at: 1.
		methodIndexes := messages collect: [:m | (SymbolTable addMethod: ((SymbolMethodEntry new) name: m)) index asString].
		code := argsCode copy asOrderedCollection.
		code addAll: initialReceiverCode.
		"methodIndexes do: [:mIndex | code add: 'PrimitiveCall call: ' , mIndex. ]."
		(code last = 'PrimitiveCall superSend') ifTrue: [
			code := code atAll: (1 to: code size - 1).
			methodIndexes do: [:mIndex | code add: 'PrimitiveCall superSend: ' , mIndex].	
		] ifFalse: [
			methodIndexes do: [:mIndex | code add: 'PrimitiveCall send: ' , mIndex].
		].
		code.
	].! !

!MetaTalkGrammar methodsFor: 'tokens' stamp: 'NickPapoulias 5/28/2011 15:48'!
binarySelector
	"comment stating purpose of message"

	^ ($/ asParser / $% asParser / $* asParser / $+ asParser / $- asParser /  $< asParser / $> asParser  / $| asParser / $& asParser   / '==' asParser / $= asParser / $, asParser) token trim ==> [:token | token value].! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/31/2011 16:27'!
blockClosure

	^ (( ($[ asParser trim , ( (argument plus , $| asParser token trim) optional ==> [:nodes | depth := depth + 1. nodes ifNotNil: [ nodes at: 1 ] ifNil: [ {} ]] )) ==> [:nodes |
			
			|arguments code|
			
			arguments := nodes at: 2.
			code := {} asOrderedCollection.
			
			SymbolTable new.
			arguments ifNotEmpty: [
				arguments do: [:arg | SymbolTable add: (SymbolArgEntry new name: arg)].
			].

			arguments ifNotEmpty: [ 
				code add: 'StackMachine push: StackMachine prev pop'.
			].
			{code. arguments size}.

	  ]) , ((varDeclaration optional) ==> [:nodes | 
			
			|locals code|
			
			locals := nodes.
			code := {} asOrderedCollection.
			
			locals ifNotNil: [
				locals do: [:local | SymbolTable add: (SymbolLocalVarEntry new name: local)].
			].
			
			locals ifNotNil: [
				code add: 'StackMachine pushNil.'.
			].
			code.
			
	]) , statement star , $] asParser trim ) ==> [:nodes |
	
			|code createBlockCode argumentsCount depthQuote|
			SymbolTable end.
			code := OrderedCollection new.
			argumentsCount := (nodes at: 1) at: 2.
			code addAll: ((nodes at: 1) at: 1).
			code addAll: (nodes at: 2).
			code addAll: (nodes at: 3).
			code add:  'StackMachine silentReturn.'.
			code := MetaTalkGrammar flatten: code.
			depthQuote := (1 to: (2 raisedTo: depth-1)) inject: '' into: [:sum :i | sum , ''''].
			createBlockCode := {'StackMachine pushNumber: ' , argumentsCount asString . 'PrimitiveCall newBlock: ' ,  '{' , (code inject: '' into: [:block :cmd | block , depthQuote , cmd asString , depthQuote , ' . ']) , '}'.} asOrderedCollection.
			depth := depth - 1.
			createBlockCode.
	].! !

!MetaTalkGrammar methodsFor: 'tokens' stamp: 'NickPapoulias 5/18/2011 14:18'!
char

	^ ( $$ asParser , (#word asParser / #punctuation asParser )) flatten token trim ==> [:token |
	
		{'StackMachine pushChar: ' , (token value at: 2) asInteger asString.} asOrderedCollection.
		
	]! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/31/2011 11:30'!
classDeclaration

	^ identifier , '=' asParser trim ,  identifier , '[' asParser trim , varDeclaration optional ==> [ :nodes |
		
		|className classEntry superEntry|

		className := nodes at: 1.
		superName := nodes at: 3.
		superEntry := SymbolTable search: superName.
		ivs := nodes at: 5.

		classEntry := (SymbolClassEntry new
							name: className;
							addIvs: ivs;
							addSuperIvs: superName).
							
		ivs := classEntry computedIvs.
		
		SymbolTable add: classEntry.
		
		SymbolTable new.
		
		ivs ifNotNil: [
			ivs do: [:iv | SymbolTable add: (SymbolIvEntry new name: iv)].
		].
		
	{classEntry . superEntry. } asArray.
	   
	] , methodDeclaration star, ']' asParser trim ==> [ :nodes |
	
		|classEntry superEntry methods code|
		
		SymbolTable end.
		
		classEntry := (nodes at: 1) at: 1.
		superEntry := (nodes at: 1) at: 2.
		methods := (nodes at: 2).
		
		code := OrderedCollection new.
		
		"default classes have 0 classVariables"
		"class can have variables only through the metalevel"
		
		code addAll: {'StackMachine pushNumber: 0' . 'StackMachine pushNumber: ', classEntry computedIvs size asString .'PrimitiveCall newClass' . classEntry genWriteCode , 'StackMachine pop.'}.
	
		methods ifNotNil: [
			methods do: [:method |
					code addAll: method.
					code add: 'StackMachine push: ' , classEntry genReadCode.
					code add: 'PrimitiveCall addMethod.'
			].
		].
	
		code add: 'StackMachine pushNumber: ' , superEntry index asString.
		code add: 'StackMachine push: ' , classEntry genReadCode.
		code add: 'PrimitiveCall setSuper'.
		code add: 'StackMachine pushNumber:' , (SymbolTable search: 'nil') index asString.
		code add: 'StackMachine push: ' , classEntry genReadCode.
		code add: 'PrimitiveCall setMirror'.
		code add: 'StackMachine pushNumber: ' , classEntry index asString.
		code add: 'StackMachine push: ' , classEntry genReadCode.
		code add: 'PrimitiveCall selfRef'.
		code add: 'StackMachine pushNumber: ' , (SymbolTable search: 'Class') index asString.
		code add: 'StackMachine push: ' , classEntry genReadCode.
		code add: 'PrimitiveCall setClass.'.
		code.
	]! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/31/2011 13:18'!
dict

	^ ${ asParser trim , 
		((((expression , '->' asParser token trim , expression) ==> [:nodes | {nodes at: 1. nodes at: 3} asOrderedCollection]) ,  $. asParser token trim) ==> [:nodes |  nodes at: 1]) star  , 
	$} asParser trim ==> [:nodes | 
		|size code|
		size := (nodes at: 2) size.
		code := (nodes at: 2) asOrderedCollection.
		code add: ('StackMachine pushNumber: ' , size asString).
		code add: 'PrimitiveCall newDict'.
		code.
	].! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/25/2011 16:36'!
expression

	^ (messageSend / baseExpr / primitive) ==> [:node | node]! !

!MetaTalkGrammar methodsFor: 'tokens' stamp: 'NickPapoulias 5/18/2011 11:06'!
identifier

	^ ( #digit asParser not , (#word asParser plus) , $: asParser not) flatten token trim ==> [:token | token value]! !

!MetaTalkGrammar methodsFor: 'start' stamp: 'NickPapoulias 5/24/2011 22:34'!
initialize 
	super initialize.
	depth := 0.! !

!MetaTalkGrammar methodsFor: 'tokens' stamp: 'NickPapoulias 5/16/2011 15:02'!
keyword

	^ (#word asParser plus, $: asParser) flatten token trim ==> [:token | token value].! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/23/2011 14:23'!
keywordMessage

	^ ((unaryMessage / binaryMessage / baseExpr)  ,
	
	  (((keyword , (unaryMessage / binaryMessage / baseExpr)) plus) ==> [:nodes |  
		|message code|
		message := nodes inject: '' into: [:keyMsg :n | keyMsg , (n at: 1)].
		code := (nodes collect: [:n | n at: 2]) reversed. "reverse argument order"
		{message . code}
	] )) ==> [:nodes |
		|message code receiver methodEntry|
		message := (nodes at: 2) at: 1.
		code := ((nodes at: 2) at: 2) asOrderedCollection.
		receiver := nodes at: 1.
		methodEntry := SymbolTable addMethod: ((SymbolMethodEntry new) name: message). "if it exists returns the existing instance"
		code addAll: receiver.
		"code add: 'PrimitiveCall call: ' , methodEntry index asString."
		(code last = 'PrimitiveCall superSend') ifTrue: [
			code := code atAll: (1 to: code size - 1).
			code add: 'PrimitiveCall superSend: ' , methodEntry index asString.
		] ifFalse: [
			code add: 'PrimitiveCall send: ' , methodEntry index asString.
		].
		code.
	]
		
	! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/31/2011 13:25'!
list

	^ (${ asParser trim , ( ( ( (expression , $. asParser token trim) ==> [:nodes | nodes at: 1]) star ) ==> [:nodes | nodes asOrderedCollection] )  , $} asParser trim) ==> [:nodes | 
		|size code|
		size := (nodes at: 2) size.
		code := (nodes at: 2).
		code add: ('StackMachine pushNumber: ' , size asString).
		code add: 'PrimitiveCall newList'.
		code.
	].! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/19/2011 10:53'!
messageSend

	^ (keywordMessage / binaryMessage / unaryMessage) ==> [:node | node].! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/30/2011 17:29'!
methodClosure

	^ ($[ asParser trim , varDeclaration optional) ==> [:nodes |

		|locals code|
		
		depth := depth + 1.
		
		locals := nodes at: 2.		
		code := OrderedCollection new.
		
		SymbolTable new.
		SymbolTable add: (SymbolLocalVarEntry new name: 'super').
		SymbolTable add: (SymbolLocalVarEntry new name: 'self').
		arguments ifNotEmpty: [
			arguments do: [:arg | SymbolTable add: (SymbolArgEntry new name: arg)].
		].
		locals ifNotNil: [
			locals do: [:local | SymbolTable add: (SymbolLocalVarEntry new name: local)].
		].
	
		code add: 'StackMachine push: ' , (SymbolTable search: superName) genReadCode.
		code add: 'StackMachine push: StackMachine prev pop'. "self"
		
		arguments ifNotEmpty: [ 
			arguments do: [:arg | code add: 'StackMachine push: StackMachine prev pop'.]
		].
	      locals ifNotNil: [
			locals do: [:local | code add: 'StackMachine pushNil'.].
		].
		{code. arguments size}
	] , (statement star) optional , $] asParser trim ==> [:nodes |

		|methodIndex code methodCode argumentsCount|
		
		methodCode := (nodes at: 1) at: 1.
		argumentsCount := (nodes at: 1) at: 2.
		methodCode addAll: (nodes at: 2).
		methodCode add: 'StackMachine silentReturn.'.
		methodIndex := (SymbolTable addMethod: (SymbolMethodEntry new name: message)) index.  
		code := OrderedCollection new.
		
		SymbolTable end.
		
		code add: ('StackMachine pushNumber: ' ,  methodIndex asString).
		methodCode := MetaTalkGrammar flatten: methodCode.
		"createBlockCode := {'StackMachine pushNumber: ' , argumentsCount asString . 'PrimitiveCall newBlock: ' ,  '{' , (code inject: '' into: [:block :cmd | block , '''' , cmd asString , '''' , ' . ']) , '}'.} asOrderedCollection."
		code add: 'StackMachine pushNumber: ' , argumentsCount asString.
		code add: ('PrimitiveCall newBlock: ' ,  '{' , (methodCode inject: '' into: [:method :cmd | method , '''' , cmd asString , '''' , ' . ']) , '}' ).
		"code add: ('PrimitiveCall methodNew.')."
		depth := depth - 1.
		code.
	]! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/19/2011 17:05'!
methodDeclaration

	^ ( (identifier ==> [:value | message := value . arguments := {}]) / 
	    ((binarySelector , identifier) ==> [:nodes | message := nodes at: 1. arguments := {nodes at: 2}])  /
	    ( ( (keyword , identifier) plus ) ==> [:nodes |
		 message := nodes inject: '' into: [:keyMsg :n | keyMsg , (n at: 1)] .
		 arguments := nodes collect: [:n | n at: 2]
	     ] ) )  , ':=' asParser trim , methodClosure ==> [:nodes |
		nodes at: 3.
	]! !

!MetaTalkGrammar methodsFor: 'tokens' stamp: 'NickPapoulias 5/18/2011 14:59'!
number

	^ (($- asParser optional) , #digit asParser plus , ($. asParser , (#digit asParser plus)) optional) flatten token trim ==> [:token |
		
		{'StackMachine pushNumber: ', token value} asOrderedCollection.
			
	]! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/18/2011 16:12'!
precedenceExp 

	^ $( asParser trim , expression , $) asParser trim ==> [:nodes | nodes at: 2 ].! !

!MetaTalkGrammar methodsFor: 'tokens' stamp: 'NickPapoulias 5/19/2011 17:05'!
primitive

	^ ( $< asParser trim , ($> asParser negate) plus flatten trim , $>asParser) trim ==> [:nodes |
	
		{nodes at: 2.} asOrderedCollection.
		
	]! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/19/2011 12:46'!
returnStatement
	
	^ ('^' asParser token trim , expression) ==> [:nodes |
		(nodes at: 2) add: 'StackMachine return.'.
		(nodes at: 2) asOrderedCollection.
	]! !

!MetaTalkGrammar methodsFor: 'start' stamp: 'NickPapoulias 5/30/2011 15:43'!
start

	^ ( (statement trim / classDeclaration trim) plus ) end ==> [:nodes | 
		(MetaTalkGrammar flatten: nodes). 
	].! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/19/2011 15:37'!
statement
	
	^ ((varAssignment / expression / returnStatement) , $. asParser trim) ==> [:nodes | nodes at: 1.].! !

!MetaTalkGrammar methodsFor: 'tokens' stamp: 'NickPapoulias 5/31/2011 16:27'!
string 

	^ ($' asParser , ('''''' asParser / $' asParser negate) star token flatten , $' asParser) trim ==> [:nodes |
		|depthQuote str|
		str := nodes at: 2.
		depthQuote := (1 to: (2 raisedTo: depth)) inject: '' into: [:sum :i | sum , ''''].
		{'StackMachine pushString: ' , depthQuote , str , depthQuote.} asOrderedCollection.
	]! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/23/2011 13:59'!
unaryMessage

	^ (baseExpr , identifier plus) ==> [:nodes |
		|receiverCode messageIndexes|
		receiverCode := (nodes at: 1) asOrderedCollection.
		messageIndexes := (nodes at: 2) collect: [:m | (SymbolTable addMethod: ((SymbolMethodEntry new) name: m)) index asString].
		(receiverCode last = 'PrimitiveCall superSend') ifTrue: [
			receiverCode := receiverCode atAll: (1 to: receiverCode size - 1).
			messageIndexes do: [:mIndex | receiverCode add: 'PrimitiveCall superSend: ' , mIndex].	
		] ifFalse: [
			messageIndexes do: [:mIndex | receiverCode add: 'PrimitiveCall send: ' , mIndex].
		].
		
		receiverCode.
	]! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/31/2011 14:02'!
varAssignment 
	
	^ identifier , ':=' asParser token trim, expression ==>  [:nodes |
			|code|
			code := (nodes at: 3) asOrderedCollection.
			[code add: ( (SymbolTable search: (nodes at: 1)) genWriteCode , 'StackMachine pop' )] on: CompilerSymbolNotFound do: [
				"first assignment at global"
				SymbolTable isGlobal ifTrue: [
					SymbolTable add: (SymbolLocalVarEntry new name: (nodes at: 1)).
					code add: (SymbolTable search: (nodes at: 1)) genWriteCode , 'StackMachine pop'.
				] ifFalse: [
					CompilerSymbolNotFound signal.
				]
			].
			code.
	].! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/16/2011 17:49'!
varDeclaration

	^ $| asParser trim , (identifier plus) , $| asParser trim ==> [:nodes | nodes at: 2] .! !

MetaTalkGrammar subclass: #MetaTalkParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

PPCompositeParserTest subclass: #MetaTalkGrammarTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!MetaTalkGrammarTest methodsFor: 'accessing' stamp: 'NickPapoulias 4/29/2011 11:48'!
parserClass
	"returns the grammar class in order to perform the tests"
	
	^ MetaTalkGrammar.! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 4/24/2011 16:16'!
testBinaryMessage

	self parse: '(point from: line1) + point y / 2' rule: #binaryMessage! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:12'!
testBinarySelector 
	
	self parse: '+' rule: #binarySelector.
	self parse: '==' rule: #binarySelector.! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:00'!
testBlockClosure! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/22/2011 14:24'!
testBoolean

	self parse: 'true' rule: #boolean.
	self parse: 'false' rule: #boolean.! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:01'!
testClassDeclaration! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 4/25/2011 11:26'!
testDict! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:01'!
testExpression! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 4/24/2011 19:09'!
testIdentifier
	"test identifiers, the actual rule is simple, just a succesion of letters"
	
	self parse: 'Object' rule: #identifier.
	self parse: 'run' rule: #identifier.! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:24'!
testKeyword
	
	self parse: 'withArguments:' rule: #keyword.! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 4/24/2011 16:47'!
testKeywordMessage

	self parse: '((point from: line) + point y / 2) log:2 inBase: 10' rule: #keywordMessage! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:01'!
testList! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:01'!
testMessageSend! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 4/25/2011 00:12'!
testMethodClosure! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:01'!
testMethodDeclaration! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:02'!
testNumber! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 4/24/2011 16:46'!
testPrecedenceExp

	self parse: '((point from: line) + point y / 2)' rule: #precedenceExp! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:02'!
testStart! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 4/24/2011 17:24'!
testStatement

	self parse: 'point x asString.' rule: #statement! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 12:58'!
testString

	self parse: '''Hallo World''' rule: #string.
	self parse: '''Hallo '''' World''' rule: #string.! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 4/24/2011 16:09'!
testUnaryMessage
	
	self parse: '(point x + point y) asString' rule: #unaryMessage! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:02'!
testVarAssignment! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:02'!
testVarDeclaration! !

MetaTalkGrammarTest subclass: #MetaTalkParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

Object subclass: #BootStrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

Object subclass: #Example
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!Example class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/19/2011 17:13'!
code

^ '

Object = nil [

	initialize := [ 
		|x y z|
		x := {3. '' hallo world ''.}. 
		y := {3 -> '' hallo world ''.}.
		z := [self allocate initialize.
		(super at: 3 put: 4) allocate.
		[^ super + y + y.] value initialize.] value.
		^ z.
	]
	allocate := [
		<PrimitiveCall smth>
	]

]

'! !

!Example class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/19/2011 14:56'!
code2

^ '

Object = nil [

	initialize := [ 
		|x y z|
		x := {3. '' hallo world ''.}. 
		y := {3 -> '' hallo world ''.}.
		z := [self allocate initialize.
		(super at: 3 put: 4) allocate.
		[^ super + y + y.] value initialize.] value.
		^ z.
	]

]

'! !

Object subclass: #Kernel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!Kernel class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/31/2011 16:40'!
code


^ '

Object = nil [

	initialize := []
	= anObject := [^ self == anObject.]
	== anObject := [^ <PrimitiveCall objEq>.]
	asString := []
	print := [self asString print.]
	
]

Class = Object [
	
	allocate := [^ <PrimitiveCall allocate>.]
	new := [
		^self allocate initialize.
	]	
	
]

Block = Object [

	initialize := [^ <PrimitiveCall blockInitialize>.]
	value := [^ <PrimitiveCall blockValue>.]	
	valueWithArgs: aList := [^ <PrimitiveCall blockValueWithArgs>.]
	whileTrue: aBlock := [
		self value ifTrue: [
			aBlock value.
			self whileTrue: aBlock.
		].
	]
	
]

Method = Object []

UndefinedObject = Object [
	
	asString := [^ ''nil''.]	
	
]

Number = Object [

	initialize := [^ <PrimitiveCall numberInitialize>.]
	= aMagnitude := [^ <PrimitiveCall numberEq>.]
	+ aNumber := [^ <PrimitiveCall numberAdd>.]
	- aNumber := [^ <PrimitiveCall numberSub>.]
	/ aNumber  := [^ <PrimitiveCall numberDiv>.]
	* aNumber := [^ <PrimitiveCall numberMul>.]
	< aNumber := [^ <PrimitiveCall numberLt>.]
	> aNumber := [^ <PrimitiveCall numberGt>.]
	floor := [^ <PrimitiveCall numberFloor>.]
	ceil := [^ <PrimitiveCall numberCeil>.]
	to: aNumber := [
		|iterator end list|
		list := {}.
		iterator := self.
		end := aNumber asNumber.
		[iterator < (end + 1).] whileTrue: [
			list add: iterator.
			iterator := iterator + 1.
		].
		^ list.
	]
	asNumber := [^ self.]
	asString := [^ <PrimitiveCall numberAsString>.]
	
]

Char = Number [
	
	asCharacter := [^ self.]
	asString := [^ String new add: self.]
	
]

Boolean = Object [

	initialize := [^ False new.]	

]

True = Boolean [

	initialize := []	
	| aBoolean := [^ true.]
	& aBoolean := [^ aBoolean.]
	not := [^ false.]
	ifTrue: aBlock := [^ aBlock value.]
	ifFalse: aBlock := [^ nil.]
	ifTrue: aBlock ifFalse: anotherBlock := [^ aBlock value.]
	asString := [^ ''true''.]
	
]

False = Boolean [
	
	initialize := []
	| aBoolean := [^ aBoolean.]
	& aBoolean := [^ false.]
	not := [^ true.]
	ifTrue: aBlock := [^ nil.]
	ifFalse: aBlock := [^ aBlock value.]
	ifTrue: aBlock ifFalse: anotherBlock := [^ anotherBlock value.]
	asString := [^ ''false''.]
	
]

List = Object [

	initialize := [^ <PrimitiveCall listInitialize>.]	
	size := [^ <PrimitiveCall listSize>.]
	add: anObject := [<PrimitiveCall listAdd>.]
	remove: anObject := [<PrimitiveCall listRemove>.]
	
	indexOf: anObject := [
		self indexAndValuesDo: [:index :value |
			(value = anObject) ifTrue: [
				^ index.	
			].
		].
	]
	
	at: index := [^ <PrimitiveCall listAt>.]
	at: index put: anObject := [<PrimitiveCall listAtPut>.]
	= aList := [^ <PrimitiveCall listEq>.]
	
	, aList := [
		|newList|
		newList := List new.
		self do: [:item | newList add: item.].
		aList asList do: [:item | newList add: item.].
		^ newList.
	]
	
	
	do: aBlock := [
		|size iterator|
		size := self size.
		iterator := 1.
		[(iterator = (size+1)) not.] whileTrue: [
			aBlock valueWithArgs: {self at: iterator.}.
			iterator := iterator + 1.
		].
	]
	
	indexAndValuesDo: aBlock := [
		|index|
		index := 1.
		self do: [:value |
			aBlock valueWithArgs: {index. value.}.
			index := index + 1.
		].	
	]

	asString := [
		|str|
		str := ''{ ''.
		self do: [:item | str := str , item asString , ''. ''.].
		^ str , ''}''.
	]

	asList := [^ self.]
]

String = List [

	add: aChar := [super add: (aChar asCharacter).]
	at: index put: aChar := [super at: index put: (aChar asCharacter).]
	print := [<PrimitiveCall stringPrint>.]
	asString := [^ self.]
	
	, aString := [
		|newString|
		newString := String new.
		self do: [:item | newString add: item.].
		aString asString do: [:item | newString add: item.].
		^ newString.
	]
		
]

Dict = List [

	add: aKeyValueList := [
		(aKeyValueList asList size = 2)	ifTrue: [
				super add: aKeyValueList.
		] ifFalse: [
				^ nil.
		].
	]

	remove: aKey := [
		self do: [:value | 
			((value at: 1) = aKey) ifTrue: [
				super remove: value.
				^ value.
			].
		].	
	]

	keyOf: aValue := [
		self do: [:value | 
			((value at: 2) = value) ifTrue: [
				^ value at: 1.
			].
		].	
	]

	at: aKey := [
		self do: [:value | 
			((value at: 1) = aKey) ifTrue: [
				^ value at: 2.
			].
		].				
	]

	at: aKey put: aValue := [
		self do: [:value | 
			((value at: 1) = aKey) ifTrue: [
				value at: 2 put: aValue.
				^ aValue.
			].
		].		
	]

	keysAndValuesDo: aBlock := [
		self do: [:value | 
			aBlock valueWithArgs: value.
		].		
	]
	

]

nil := UndefinedObject new.

true := True new.

false := False new.

(1 = 1) not print.

(1 + 2) print.

(true & true) print.

(true & false) print.

''hallo world !!'' print.

x := 1.

x = 2 ifTrue: [
	''this should not be printed.'' print.
] ifFalse: [
	''block evaluation successfull.'' print.
].

(1 to: 10) print.

{''MetaTalk''. ''List''.} print.

3 asString print.

(1 to: 10) do: [:i | (i * 2) print.].

(''con'',''catenation '',''is working'') print.

'! !

Object subclass: #MetaKernel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!MetaKernel class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/27/2011 20:17'!
code

"reflection and a slight form of intercession, executional reflection in the form of interpretation"

^ '

AbstractMirror = Object [

	on: aBaseObject := []

	class := []
	ivNames := []
	at: varName := []
	at: varName	 put: anObject := []
	perform: aMethodName withArguments: args := []
	print := []	
	
]

AbstractMirrorClass = AbstractMirror [
	
	name := []	
	super := []
	methodNames := []
	instanceIvNames := []
	at: methodName := []
	
]

AbstractMirrorMethod = AbstractMirror [
	
	localNames := []	
	definedInClass := []
	
]

AbstractMirrorStatement = Object [
	
	expressions := []

]

Mirror = AbstractMirror [
	
	|baseObj ivs class|
	
	on: aBaseObject := []
	ivNames := []
	at: varName := []
	at: varName	 put: anObject := []
	perform: aMethodName withArguments: args := []
	class := []
	print := []
	
]

MirrorClass = AbstractMirrorClass [
	
	|name super methodDict instanceIvs methods|
	
	newMirrorClassFor: aClass named: className inhertisFrom: superClass methodDict: mDict ivs: ivs := []
	
	name := []	
	super := []
	methodNames := []
	ivNames := []
	atMethod: methodName := []
	
	newBaseClass: aClassName := []
	class: aClass := []
	super: aSuperClass := []
	ivs: instanceVariables := []
	addMethodNamed: aMethodName codeForMethod named: aMethodName := [call the MirrorMethod constructor]
	
]

MirrorMethod = AbstractMirrorMethod [
	
	|name numberOfArgs args localNames inClass code statements|

	newWithLocals: locals inClass: class andStatements: stmts
		
	localNames := []	
	definedInClass := []
	statements := []
	
]


'! !

Object subclass: #MigrationProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

Object subclass: #NetworkProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

Object subclass: #ObjectRepresentation
	instanceVariableNames: 'hostType classRef ivs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!ObjectRepresentation commentStamp: '<historical>' prior: 0!
Object Representation in the host language. No pre-assumptions made only slots (a smalltalk array) is present (which is equivalent of having an initial memory address and thus being able to access subsequent addresses through pointer arithmetic)

Instance Variables:
	slots	<Object>!

ObjectRepresentation subclass: #ObjectClassRepresentation
	instanceVariableNames: 'mirror superClass methodDict instanceSize selfRef'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!ObjectClassRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/31/2011 11:12'!
initialize

	super initialize.
	mirror := nil.
	superClass := nil.
	instanceSize := 0.
	selfRef := nil.
	classRef := StackMachine defaultIndexOf: 'Class'.
	methodDict := Dictionary new.! !

!ObjectClassRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/27/2011 20:28'!
instanceSize
	^ instanceSize! !

!ObjectClassRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/27/2011 20:28'!
instanceSize: anObject
	instanceSize := anObject! !

!ObjectClassRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/1/2011 19:27'!
methodAt: index

	^ methodDict at: index.! !

!ObjectClassRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/1/2011 19:27'!
methodAt: index put: anObjectCompiledBlockRepresentation

	^ methodDict at: index put: anObjectCompiledBlockRepresentation.! !

!ObjectClassRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/12/2011 13:11'!
methodDict
	^ methodDict! !

!ObjectClassRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/29/2011 23:16'!
methodDict1: anObject
	methodDict := anObject! !

!ObjectClassRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/16/2011 21:28'!
methodDict: anObject
	|assocDict|
	
	assocDict := anObject asDictionary.
	assocDict keysAndValuesDo: [:key :value | 
			methodDict at: key put: (ObjectCompiledBlockRepresentation new isMethod: true; compiledBlockAsHostString: value).  
	]  ! !

!ObjectClassRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/12/2011 13:11'!
mirror
	^ mirror! !

!ObjectClassRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/12/2011 13:11'!
mirror: anObject
	mirror := anObject! !

!ObjectClassRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/29/2011 23:16'!
selfRef
	^ selfRef! !

!ObjectClassRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/29/2011 23:16'!
selfRef: anObject
	selfRef := anObject! !

!ObjectClassRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/1/2011 19:29'!
superClass

	^ superClass.! !

!ObjectClassRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/1/2011 19:25'!
superClass: anObjectClassRepresentation

	superClass := anObjectClassRepresentation.! !

ObjectRepresentation subclass: #ObjectCompiledBlockRepresentation
	instanceVariableNames: 'compiledBlockAsHostStringList bindedStack argCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!ObjectCompiledBlockRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/23/2011 14:47'!
argCount
	^ argCount! !

!ObjectCompiledBlockRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/23/2011 14:47'!
argCount: anObject
	argCount := anObject! !

!ObjectCompiledBlockRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/8/2011 16:18'!
bindedStack
	^ bindedStack! !

!ObjectCompiledBlockRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/8/2011 16:18'!
bindedStack: anObject
	bindedStack := anObject! !

!ObjectCompiledBlockRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/18/2011 16:27'!
compiledBlockAsHostStringList
	^ compiledBlockAsHostStringList! !

!ObjectCompiledBlockRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/18/2011 16:27'!
compiledBlockAsHostStringList: anObject
	compiledBlockAsHostStringList := anObject! !

!ObjectCompiledBlockRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/31/2011 11:13'!
initialize

	super initialize.
	classRef := StackMachine defaultIndexOf: 'Block'.
	bindedStack := StackMachine currentStack.! !

ObjectRepresentation subclass: #ObjectListRepresentation
	instanceVariableNames: 'hostListRepresentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!ObjectListRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/17/2011 11:42'!
hostListRepresentation
	^ hostListRepresentation! !

!ObjectListRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/17/2011 11:42'!
hostListRepresentation: anObject
	hostListRepresentation := anObject! !

!ObjectListRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/31/2011 11:13'!
initialize 
	super initialize.
	classRef := StackMachine defaultIndexOf: 'List'.
	hostListRepresentation := OrderedCollection new.! !

!ObjectListRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/30/2011 15:27'!
printOn: aStream

	classRef = (StackMachine defaultIndexOf: 'String') ifFalse: [
		aStream nextPutAll: hostListRepresentation asString.
	] ifTrue: [
		aStream nextPutAll:  (hostListRepresentation inject: '' into: [:string :char | string , char hostNumberRepresentation asCharacter asString]).
	]! !

ObjectRepresentation subclass: #ObjectNumberRepresentation
	instanceVariableNames: 'hostNumberRepresentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!ObjectNumberRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/12/2011 15:46'!
hostNumberRepresentation
	^ hostNumberRepresentation! !

!ObjectNumberRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/12/2011 15:46'!
hostNumberRepresentation: anObject
	hostNumberRepresentation := anObject! !

!ObjectNumberRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/31/2011 11:13'!
initialize 
	super initialize.
	classRef := StackMachine defaultIndexOf: 'Number'.
	hostNumberRepresentation := 0.! !

!ObjectNumberRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/30/2011 15:25'!
printOn: aStream 

	aStream nextPutAll: hostNumberRepresentation asString.  

	! !

!ObjectRepresentation class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2011 11:53'!
initialize 
	"don't forget to set the target language classes for these default objects"
	super initialize.! !

!ObjectRepresentation class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 13:22'!
new: ivSize

	^ self new size: ivSize.! !

!ObjectRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/1/2011 19:24'!
at: index

	^ ivs at: index.! !

!ObjectRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/1/2011 19:24'!
at: index put: anObjectRepresentation

	^ ivs at: index put: anObjectRepresentation.! !

!ObjectRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/29/2011 17:20'!
classRef
	^ classRef! !

!ObjectRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/29/2011 17:20'!
classRef: anObject
	classRef := anObject! !

!ObjectRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/9/2011 13:13'!
hostType

	^ hostType! !

!ObjectRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/1/2011 19:20'!
hostType: objectRepresentationType

	hostType := objectRepresentationType.! !

!ObjectRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/31/2011 11:12'!
initialize 

	super initialize.
	self hostType: self class.
	classRef := StackMachine defaultIndexOf: 'Object'.
	ivs := nil.! !

!ObjectRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/28/2011 16:38'!
ivs
	^ ivs! !

!ObjectRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/28/2011 16:38'!
ivs: anObject
	ivs := anObject! !

!ObjectRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2011 15:58'!
longPrintOn: aStream

	self class allInstVarNames doWithIndex:
		[:title :index |
			aStream nextPutAll: title;
			nextPutAll: ': ';
		 	print: (self instVarAt: index);
			nextPutAll: ' . '
	].! !

!ObjectRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2011 16:18'!
printOn: aStream

	aStream nextPutAll: hostType asString  ! !

!ObjectRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2011 15:55'!
size

	ivs isNil ifTrue: [^ 0] ifFalse: [ ^ ivs size].! !

!ObjectRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 13:21'!
size: ivSize

	ivs := Array new: ivSize.! !

Object subclass: #PrimitiveCall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!PrimitiveCall commentStamp: '<historical>' prior: 0!
These are primitive calls which presume the correct inference of boundary and representation checks by the compiler and thus that vmMirrors references have been discarded.!

!PrimitiveCall class methodsFor: 'mirrorClass' stamp: 'NickPapoulias 5/31/2011 11:09'!
addMethod
	
	|class block methodIndex|
	
	class := StackMachine pop.
	block := StackMachine pop.
	block classRef: (StackMachine defaultIndexOf: 'Method').
	methodIndex := StackMachine pop hostNumberRepresentation.
	class methodAt: methodIndex put: block.! !

!PrimitiveCall class methodsFor: 'class' stamp: 'NickPapoulias 5/30/2011 17:33'!
allocate

	|selfClass representationType size|
	
	selfClass := StackMachine pop.
	size := selfClass instanceSize.
	StackMachine push: (ObjectRepresentation new classRef: selfClass selfRef; size: size).

	! !

!PrimitiveCall class methodsFor: 'block' stamp: 'NickPapoulias 5/31/2011 14:23'!
blockInitialize

	|selfObj|	
	
	selfObj := StackMachine atSelf.
	
	(selfObj hostType = ObjectRepresentation) ifTrue: [
	 	"class new has returned an allocated objectRepresentation with the correct size and class, if ivs are already set
		from subclass copy them, the subclass should always return the super initialize in this case"
		|size class ivs|
		size := selfObj size.
		class := selfObj classRef.
		ivs := selfObj ivs.
		StackMachine push: (ObjectCompiledBlockRepresentation new classRef: class; ivs: ivs).
		
	] ifFalse: [
	
		StackMachine push: selfObj.
	
	]! !

!PrimitiveCall class methodsFor: 'block' stamp: 'NickPapoulias 5/30/2011 11:56'!
blockValue

	StackMachine load: (StackMachine atSelf).
	! !

!PrimitiveCall class methodsFor: 'block' stamp: 'NickPapoulias 5/31/2011 14:25'!
blockValueWithArgs

	|selfObj aListRepresentation|
	selfObj := StackMachine atSelf.
	aListRepresentation := StackMachine pop.
	(aListRepresentation hostListRepresentation size = selfObj argCount) not ifTrue: [VMWrongNumberOfArgs signal].
	aListRepresentation hostListRepresentation do: [:item |
			StackMachine push: item.
	].
	StackMachine load: selfObj.
	! !

!PrimitiveCall class methodsFor: 'list' stamp: 'NickPapoulias 5/30/2011 11:58'!
listAdd
	
	(StackMachine atSelf) hostListRepresentation add: StackMachine pop.! !

!PrimitiveCall class methodsFor: 'list' stamp: 'NickPapoulias 5/30/2011 11:58'!
listAt
	
	StackMachine push: ((StackMachine atSelf) hostListRepresentation at: StackMachine pop hostNumberRepresentation).! !

!PrimitiveCall class methodsFor: 'list' stamp: 'NickPapoulias 5/30/2011 11:58'!
listAtPut
	
	(StackMachine atSelf) hostListRepresentation at: StackMachine pop hostNumberRepresentation put: StackMachine pop.! !

!PrimitiveCall class methodsFor: 'list' stamp: 'NickPapoulias 5/30/2011 11:59'!
listEq
	
	((StackMachine atSelf) = StackMachine pop) ifTrue: [
			StackMachine pushTrue.
	] ifFalse: [
			StackMachine pushFalse.
	].! !

!PrimitiveCall class methodsFor: 'list' stamp: 'NickPapoulias 5/31/2011 14:24'!
listInitialize 
	
	|selfObj|	
	
	selfObj := StackMachine atSelf.
	
	(selfObj hostType = ObjectRepresentation) ifTrue: [
	 	"class new has returned an allocated objectRepresentation with the correct size and class, if ivs are already set
		from subclass copy them, the subclass should always return the super initialize in this case"
		|size class ivs|
		size := selfObj size.
		class := selfObj classRef.
		ivs := selfObj ivs.
		StackMachine push: (ObjectListRepresentation new classRef: class; ivs: ivs).
		
	] ifFalse: [
	
		StackMachine push: (selfObj).
	
	]! !

!PrimitiveCall class methodsFor: 'list' stamp: 'NickPapoulias 5/30/2011 12:00'!
listRemove
	
	(StackMachine atSelf) hostListRepresentation remove: StackMachine pop.! !

!PrimitiveCall class methodsFor: 'list' stamp: 'NickPapoulias 5/31/2011 14:57'!
listSize
	
	StackMachine push: (ObjectNumberRepresentation new hostNumberRepresentation: (StackMachine atSelf hostListRepresentation) size).! !

!PrimitiveCall class methodsFor: 'block' stamp: 'NickPapoulias 5/30/2011 11:57'!
newBlock: blockAsHostList
	
	|argCount|
	
	argCount := StackMachine pop hostNumberRepresentation.
	  
	StackMachine push: (ObjectCompiledBlockRepresentation new
								compiledBlockAsHostStringList: blockAsHostList;
								argCount: argCount;
								bindedStack: StackMachine currentStack;
								yourself).! !

!PrimitiveCall class methodsFor: 'mirrorClass' stamp: 'NickPapoulias 5/30/2011 13:56'!
newClass
	"by default make it an instance of Class and override with other primitive"
	|instanceSize classSize|
	
	instanceSize := StackMachine pop hostNumberRepresentation.
	classSize := StackMachine pop hostNumberRepresentation.
	StackMachine push: (ObjectClassRepresentation new size: classSize; instanceSize: instanceSize).
	

	! !

!PrimitiveCall class methodsFor: 'dict' stamp: 'NickPapoulias 5/31/2011 13:28'!
newDict

	|size dict|
	
	size := StackMachine pop hostNumberRepresentation.
	dict := ObjectListRepresentation new classRef: (StackMachine defaultIndexOf: 'Dict').
	(1 to: size) do: [:i |
		|tuple value key|
		tuple :=	 ObjectListRepresentation new.
		value := StackMachine pop.
		key := StackMachine pop.
		tuple hostListRepresentation add: key.
		tuple hostListRepresentation add: value.
		dict hostListRepresentation addFirst: tuple.
	].
	StackMachine push: dict.! !

!PrimitiveCall class methodsFor: 'list' stamp: 'NickPapoulias 5/31/2011 13:26'!
newList

	
	|size list|
	
	size := StackMachine pop hostNumberRepresentation.
	list := ObjectListRepresentation new.
	(1 to: size) do: [:i |
		list hostListRepresentation addFirst: StackMachine pop.
	].
	StackMachine push: list.! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/30/2011 12:08'!
numberAdd
	
	StackMachine push: (ObjectNumberRepresentation new hostNumberRepresentation:  (StackMachine atSelf) hostNumberRepresentation + StackMachine pop hostNumberRepresentation).    ! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/31/2011 11:15'!
numberAsString

	StackMachine push: (ObjectListRepresentation new classRef: (StackMachine defaultIndexOf: 'String'); hostListRepresentation:  (
		(StackMachine atSelf hostNumberRepresentation asString) asOrderedCollection collect: [:char | ObjectNumberRepresentation new classRef:
			(StackMachine defaultIndexOf: 'Char' ); hostNumberRepresentation: char asciiValue.]
	)).
	! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/30/2011 12:10'!
numberCeil
	
	StackMachine push: (ObjectNumberRepresentation new  hostNumberRepresentation: (StackMachine atSelf hostNumberRepresentation ceiling)).! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/30/2011 12:11'!
numberDiv
	
	StackMachine push: (ObjectNumberRepresentation new hostNumberRepresentation:  (StackMachine atSelf) hostNumberRepresentation / StackMachine pop hostNumberRepresentation).   ! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/30/2011 12:11'!
numberEq
	
	|selfObj aNumber|
	selfObj := StackMachine atSelf.
	aNumber := StackMachine pop.
	selfObj hostNumberRepresentation = aNumber hostNumberRepresentation ifTrue: [
		StackMachine pushTrue.	
	] ifFalse: [
		StackMachine pushFalse.
	].! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/30/2011 12:11'!
numberFloor
	
	StackMachine push: (ObjectNumberRepresentation new 
								hostNumberRepresentation: (StackMachine atSelf hostNumberRepresentation floor)).! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/30/2011 12:12'!
numberGt
	
	|selfObj aNumber|
	selfObj := StackMachine atSelf.
	aNumber := StackMachine pop.
	selfObj hostNumberRepresentation > aNumber hostNumberRepresentation ifTrue: [
		StackMachine pushTrue.
	] ifFalse: [
		StackMachine pushFalse.
	].! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/31/2011 14:24'!
numberInitialize
	
	|selfObj|	
	
	selfObj := StackMachine pop.
	
	(selfObj hostType = ObjectRepresentation) ifTrue: [
	 	"class new has returned an allocated objectRepresentation with the correct size and class, if ivs are already set
		from subclass copy them, the subclass should always return the super initialize in this case"
		|size class ivs|
		size := selfObj size.
		class := selfObj classRef.
		ivs := selfObj ivs.
		^ ObjectNumberRepresentation new classRef: class; ivs: ivs.
		
	] ifFalse: [
	
		^ selfObj.
	
	]! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/30/2011 12:28'!
numberLt
	
	|selfObj aNumber|
	selfObj := StackMachine atSelf.
	aNumber := StackMachine pop.
	selfObj hostNumberRepresentation < aNumber hostNumberRepresentation ifTrue: [
		StackMachine pushTrue.
	] ifFalse: [
		StackMachine pushFalse
	].! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/30/2011 13:08'!
numberMul
	
	StackMachine push: (ObjectNumberRepresentation new hostNumberRepresentation:  (StackMachine atSelf) hostNumberRepresentation * StackMachine pop hostNumberRepresentation).   ! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/30/2011 13:10'!
numberSub
	
	StackMachine push: (ObjectNumberRepresentation new; hostNumberRepresentation:  (StackMachine atSelf) hostNumberRepresentation - StackMachine pop hostNumberRepresentation).   ! !

!PrimitiveCall class methodsFor: 'object' stamp: 'NickPapoulias 5/30/2011 13:10'!
objEq
	
	|selfObj anObject|
	selfObj := StackMachine atSelf.
	anObject := StackMachine pop.
	selfObj  == anObject ifTrue: [
		StackMachine pushTrue.
	] ifFalse: [
		StackMachine pushFalse.
	].

	! !

!PrimitiveCall class methodsFor: 'mirrorClass' stamp: 'NickPapoulias 5/31/2011 11:09'!
selfRef
	
	StackMachine pop selfRef: StackMachine pop hostNumberRepresentation.

	! !

!PrimitiveCall class methodsFor: 'lookup' stamp: 'NickPapoulias 5/31/2011 14:45'!
send: methodIndex

	|selfObj class method|

	selfObj := StackMachine pop.
	class := selfObj classRef.
	method := nil.
	
	[((class = (StackMachine defaultIndexOf: 'nil') ) not) & (method isNil)] whileTrue: [
		class := StackMachine globalStack at: class.
		(class methodDict includesKey: methodIndex) ifTrue: [
			method := class methodDict at: methodIndex.	
		] ifFalse: [
			class := class superClass.
		]
	].

	(method = nil) ifTrue: [VMSendException signal].
	
	StackMachine push: selfObj.
	StackMachine load: method.
	! !

!PrimitiveCall class methodsFor: 'mirrorClass' stamp: 'NickPapoulias 5/31/2011 11:09'!
setClass
	
	StackMachine pop classRef: StackMachine pop hostNumberRepresentation.

! !

!PrimitiveCall class methodsFor: 'mirrorClass' stamp: 'NickPapoulias 5/31/2011 11:09'!
setMirror

	StackMachine pop mirror: StackMachine pop hostNumberRepresentation.! !

!PrimitiveCall class methodsFor: 'mirrorClass' stamp: 'NickPapoulias 5/31/2011 11:09'!
setSuper
	
	StackMachine pop superClass: StackMachine pop hostNumberRepresentation.

	! !

!PrimitiveCall class methodsFor: 'string' stamp: 'NickPapoulias 5/31/2011 16:38'!
stringPrint
	
	Transcript show: 'MetaTalk>>> '; show: ((StackMachine atSelf hostListRepresentation) inject: '' into: [:string :char | string , char hostNumberRepresentation asCharacter asString]);
	show: Character cr.! !

!PrimitiveCall class methodsFor: 'lookup' stamp: 'NickPapoulias 5/31/2011 14:45'!
superSend: methodIndex

	|selfObj superClass method|
	
	superClass := StackMachine pop selfRef.
	selfObj := StackMachine pop.
	method := nil.
	
	[(superClass = (StackMachine defaultIndexOf: 'nil')) not & (method isNil)] whileTrue: [
		superClass := StackMachine globalStack at: superClass.
		(superClass methodDict includesKey: methodIndex) ifTrue: [
			method := superClass methodDict at: methodIndex.	
		] ifFalse: [
			superClass := superClass superClass.
		]
	].

	(method = nil) ifTrue: [VMSendException signal].
	
	StackMachine push: selfObj.
	StackMachine load: method.! !

Object subclass: #StackMachine
	instanceVariableNames: 'stack compiledBlock pc'
	classVariableNames: 'currentStack defaultIndex globalEnvSize globalPC loadedCode stackOfStacks'
	poolDictionaries: ''
	category: 'MetaTalk'!

StackMachine class
	instanceVariableNames: 'loadedBlock globalEnvSize'!

StackMachine class
	instanceVariableNames: 'loadedBlock globalEnvSize'!

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:44'!
at: index

	^ currentStack at: index.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/23/2011 17:46'!
at: index put: anObjectRepresentation

	currentStack at: index put: anObjectRepresentation.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/31/2011 13:46'!
atSelf
	"used by primitives only, actual code knows the index of self, by compilation"
	
	^ currentStack atSelf.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2011 16:56'!
clear

	globalPC := 0.
	currentStack := nil.
	stackOfStacks := OrderedCollection new.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:44'!
compiledBlock

	^ currentStack compiledBlock.    ! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:44'!
compiledBlock: aBlock

	^ currentStack compiledBlock: aBlock.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/16/2011 20:52'!
currentStack

	^ currentStack.
		! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2011 13:55'!
defaultIndexOf: aName

	^ defaultIndex at: aName.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/31/2011 11:33'!
globalPC

	^ globalPC

  ! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/31/2011 11:33'!
globalPCInc

	globalPC := globalPC + 1.

  ! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:51'!
globalStack

	(stackOfStacks isEmpty) ifFalse: [
		^ stackOfStacks at: 1.
	] ifTrue: [
		^ nil
	].
		! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2011 16:56'!
initialize

	super initialize.
	stackOfStacks := OrderedCollection new.
	defaultIndex := {'nil'->1.'true'->2. 'false'->3.'Object'->4.'Class'->5.'Block'->6.'Method'->7.'UndefinedObject'->8.'Number'->9.'Char'->10.'Boolean'->11.'True'->12.
	'False'->13.'List'->14.'String'->15.'Dict'->16} asDictionary.
	globalPC := 0.
	globalEnvSize := 40.
	currentStack := nil.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/31/2011 12:01'!
load: codeOrBlock
	"initial load and lookup load, SM new binds this block closure to the stack"
	(codeOrBlock class = ObjectCompiledBlockRepresentation) ifTrue: [
			loadedBlock := codeOrBlock.
			StackMachine new.
	] ifFalse: ["top level stack"
			loadedBlock := ObjectCompiledBlockRepresentation new
								compiledBlockAsHostStringList: codeOrBlock;
								argCount: 0;
								bindedStack: nil;
								yourself.
			StackMachine new.
			StackMachine push: (ObjectRepresentation new classRef: (StackMachine defaultIndexOf: 'UndefinedObject')).
			StackMachine push: (ObjectRepresentation new classRef: (StackMachine defaultIndexOf: 'True')).
			StackMachine push: (ObjectRepresentation new classRef: (StackMachine defaultIndexOf: 'False')).
			(1 to: globalEnvSize) do: [:i | StackMachine push: nil.]
	]! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/23/2011 16:21'!
new
	loadedBlock ifNotNil: [
		currentStack := self basicNew initialize.
		stackOfStacks addLast: currentStack.
		currentStack compiledBlock: loadedBlock.
		^ currentStack.
	] ifNil: [^ nil]! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:45'!
pc

	^ currentStack pc.

  ! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:45'!
pcInc

	^ currentStack pcInc.

  ! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:45'!
pop

	^ currentStack pop.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 14:26'!
prev

	^ stackOfStacks at: (stackOfStacks indexOf: currentStack) - 1.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2011 16:20'!
printOn: aStream 

	stackOfStacks doWithIndex: [:stack :index | 
		aStream nextPut: Character cr.
		aStream nextPutAll: '====================  (', index asString , ')  ==================== '.
		aStream nextPut: Character cr.
		stack longPrintOn: aStream.
		aStream nextPut: Character cr.
	]  ! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:45'!
push: anObjectRepresentation
	
	currentStack push: anObjectRepresentation.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/31/2011 13:28'!
pushChar: aHostNumber

	StackMachine push: (ObjectNumberRepresentation new classRef: (StackMachine defaultIndexOf: 'Char'); hostNumberRepresentation: aHostNumber).
! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2011 11:22'!
pushFalse

	StackMachine push: (StackMachine globalStack at: (StackMachine defaultIndexOf: 'false')).! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2011 11:23'!
pushNil

	StackMachine push: (StackMachine globalStack at: (StackMachine defaultIndexOf: 'nil')).! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2011 11:23'!
pushNumber: aHostNumber
	
	StackMachine push: (ObjectNumberRepresentation new hostNumberRepresentation: aHostNumber).! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2011 17:31'!
pushString: aHostString

	StackMachine push: (ObjectListRepresentation new classRef: (StackMachine defaultIndexOf: 'String'); hostListRepresentation:  (
		aHostString asOrderedCollection collect: [:char | ObjectNumberRepresentation new classRef: (StackMachine defaultIndexOf: 'Char') ; hostNumberRepresentation: char asciiValue.]
	)).! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2011 11:25'!
pushTrue

	StackMachine push: (StackMachine globalStack at: (StackMachine defaultIndexOf: 'true')).! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 15:30'!
remove
	
	stackOfStacks remove: currentStack.
	currentStack := stackOfStacks last.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2011 17:00'!
return
	"should unwind the stack till the methodStack where the executing block originated"
	"all methods have the global stack as bindedStack, but this does not mean that the previous is the global"
	
	(self compiledBlock classRef = (self defaultIndexOf: 'Method') ) ifTrue: [
		self prev push: self pop.
		self remove.		
	] ifFalse: [
	
		|bStack|
	
		bStack := self compiledBlock bindedStack.
	
		bStack ifNil: [ ^ nil]. "top stack--a return should not even be compiled"
	
		[ (bStack  == currentStack) not ] whileTrue: [
			self prev push: self pop.
			self remove.
		].
	
		self return.
	]! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/25/2011 14:53'!
run

	|running|
	running := self step.
	[running notNil] whileTrue: [running := self step]! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/31/2011 11:53'!
runUntil: globalPCValue

	|running|
	running := self step.
	[running notNil & (globalPC = (globalPCValue - 1)) not] whileTrue: [running := self step].
	self stepTrace.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2011 17:01'!
silentReturn
	
	(self compiledBlock classRef = (self defaultIndexOf: 'Method') ) ifFalse: [
		self prev push: self pop.
		self remove.	
	] ifTrue: [
		self prev push: self atSelf.
		self remove.
	]! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/24/2011 20:43'!
stackAt: offsetFromBindedStack

	|stack|

	stack := currentStack.

	1 to: offsetFromBindedStack abs do: [: i |
		stack := stack compiledBlock bindedStack.
	].

	^ stack.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/31/2011 11:23'!
step
	(self pc = self compiledBlock compiledBlockAsHostStringList size) ifFalse: [
		self pcInc.
		self globalPCInc.
		Compiler evaluate: (self compiledBlock compiledBlockAsHostStringList at: self pc).
	] ifTrue: [
		"print the last value"
		^ nil.
	]! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/31/2011 11:23'!
stepTrace
	(self pc = self compiledBlock compiledBlockAsHostStringList size) ifFalse: [
		self pcInc.
		self globalPCInc.
		Transcript show: Character cr; show: (self compiledBlock compiledBlockAsHostStringList at: self pc); show: ' (', self pc asString , ',' , globalPC asString ,')'; show: Character cr.
		Compiler evaluate: (self compiledBlock compiledBlockAsHostStringList at: self pc).
		Transcript show: StackMachine.
	] ifTrue: [
		"print the last value"
		^ nil.
	]! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2011 15:33'!
trace

	|running|
	running := self stepTrace.
	[running notNil] whileTrue: [running := self stepTrace]! !

!StackMachine methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/23/2011 18:09'!
at: index

	^ stack at: index.! !

!StackMachine methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2011 14:26'!
at: index put: anObjectRepresentation

	stack at: index put: anObjectRepresentation.! !

!StackMachine methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/31/2011 13:46'!
atSelf

	^ stack at: 2.! !

!StackMachine methodsFor: 'accessing' stamp: 'NickPapoulias 5/6/2011 12:49'!
compiledBlock
	^ compiledBlock! !

!StackMachine methodsFor: 'accessing' stamp: 'NickPapoulias 5/6/2011 12:49'!
compiledBlock: anObject
	compiledBlock := anObject! !

!StackMachine methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/30/2011 16:56'!
initialize 

	super initialize.
	stack := OrderedCollection new.
	pc := 0.
	compiledBlock := ''! !

!StackMachine methodsFor: 'accessing' stamp: 'NickPapoulias 5/31/2011 12:01'!
longPrintOn: aStream

	stack doWithIndex: [:obj :index | 
		obj ifNotNil: [
			aStream nextPutAll: (index asString , ') '). 
			obj longPrintOn: aStream. 
			aStream nextPut: Character cr.
			aStream nextPutAll: '-----------------------------------------------------------------'.
			aStream nextPut: Character cr.
		].
	]! !

!StackMachine methodsFor: 'accessing' stamp: 'NickPapoulias 5/6/2011 12:49'!
pc
	^ pc! !

!StackMachine methodsFor: 'accessing' stamp: 'NickPapoulias 5/6/2011 12:50'!
pcInc
	pc := pc + 1.! !

!StackMachine methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 14:28'!
pop

	^ stack removeLast.! !

!StackMachine methodsFor: 'accessing' stamp: 'NickPapoulias 5/30/2011 16:21'!
printOn: aStream

	aStream nextPutAll: (stackOfStacks indexOf: self) asString.! !

!StackMachine methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 14:28'!
push: anObjectRepresentation

	stack add: anObjectRepresentation.! !

!StackMachine methodsFor: 'accessing' stamp: 'NickPapoulias 5/9/2011 14:11'!
stack

	^ stack! !

!StackMachine methodsFor: 'accessing' stamp: 'NickPapoulias 5/9/2011 14:11'!
stack: anObject

	stack := anObject! !

Object subclass: #SymbolTable
	instanceVariableNames: 'scope'
	classVariableNames: 'currentScope methodList scopeList'
	poolDictionaries: ''
	category: 'MetaTalk'!

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2011 11:37'!
add: aSymbolTableEntry

	^ currentScope add: aSymbolTableEntry.
! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/19/2011 14:24'!
addMethod: aMethodTableEntry

	^ methodList detect: [:method | method name = aMethodTableEntry name] ifNone: [
		methodList add: (aMethodTableEntry scope: methodList).
		^ aMethodTableEntry.
	]
! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2011 11:34'!
clear

	currentScope := nil.
	scopeList := OrderedCollection new.
	methodList := OrderedCollection new.! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 16:23'!
end

	scopeList remove: currentScope.
	currentScope := scopeList last.! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2011 11:34'!
initialize 

	super initialize.
	scopeList := OrderedCollection new.
	currentScope := nil.
	methodList := OrderedCollection new.! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/16/2011 20:13'!
isGlobal

	^ ( (scopeList indexOf: currentScope) = 1)! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/2/2011 15:24'!
new 

	currentScope := self basicNew initialize.
	scopeList add: currentScope.
	^ currentScope.! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/4/2011 16:31'!
offsetFrom: aScope

	^ (scopeList indexOf: aScope) - (scopeList indexOf: currentScope).
! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/16/2011 20:04'!
scopeList

	^ scopeList
! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/31/2011 14:02'!
search: aName

	|entry|
	scopeList reversed detect: [:s | (entry := s search: aName) notNil] ifNone: [CompilerSymbolNotFound signal].
	^ entry.
! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2011 13:02'!
searchMethod: aName

	^ methodList detect: [:s | (s name = aName)] ifNone: [^ nil].
! !

!SymbolTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/17/2011 12:34'!
add: aSymbolTableEntry

	(self search: aSymbolTableEntry name) ifNotNil: [
			scope at: (scope indexOf: (self search: aSymbolTableEntry name)) put: (aSymbolTableEntry scope: self).
		] ifNil: [
		scope add: (aSymbolTableEntry scope: self).
	].   
	! !

!SymbolTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/4/2011 16:35'!
indexOf: anEntry

	^ scope indexOf: anEntry.  ! !

!SymbolTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/6/2011 12:08'!
initialize 

	scope := OrderedCollection new.
	bindings := OrderedCollection new.! !

!SymbolTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/16/2011 20:17'!
isGlobal

	^ ( (scopeList indexOf: self) = 1 )! !

!SymbolTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/4/2011 16:25'!
search: aName
	
	^ scope detect: [:e | e name = aName] ifNone: [nil].
! !

Object subclass: #SymbolTableEntry
	instanceVariableNames: 'name scope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!SymbolTableEntry commentStamp: 'NickPapoulias 5/12/2011 11:46' prior: 0!
Optimally all symbolTable entries should be interconnected producing a comprehensive syntax tree of the code.
As of now only the minimum of the information required in order to compile are kept.
In the future these classes will be used for compiled time meta-information.

SymbolTableEntry has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	name	<String>
	scope	<FMRepositoryVisitor | HismoAbstractHistory | Matrix | MooseGroup | OBFan | OBList | SequenceableCollection | SymbolTable>!

SymbolTableEntry subclass: #SymbolArgEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

SymbolTableEntry subclass: #SymbolClassEntry
	instanceVariableNames: 'computedIvs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!SymbolClassEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/12/2011 11:40'!
addIv: aName

	computedIvs add: aName.! !

!SymbolClassEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/15/2011 22:17'!
addIvs: aListOfNames

	aListOfNames ifNotNil: [
		computedIvs addAll: aListOfNames.
	].! !

!SymbolClassEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/15/2011 22:16'!
addSuperIvs: aSuperClassName

	|superClass|
	superClass := SymbolTable search: aSuperClassName.
	superClass ifNotNil: [ 
		(superClass name = 'nil') not ifTrue: [
			computedIvs addAll: superClass computedIvs 
		].
	].! !

!SymbolClassEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/12/2011 11:40'!
computedIvs

	^ computedIvs! !

!SymbolClassEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/12/2011 11:40'!
initialize 

	super initialize.
	computedIvs := OrderedCollection new.! !

SymbolTableEntry subclass: #SymbolIvEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!SymbolIvEntry methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/17/2011 12:48'!
genAssignCode

	^ ' Primitive selfAssingAt: ' ,  self index asString.! !

!SymbolIvEntry methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 16:09'!
genReadCode

	^ ' Primitive selfAt: ' ,  self index asString.! !

!SymbolIvEntry methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 16:09'!
genWriteCode

	^ ' Primitive selfAt: ' ,  self index asString , ' put:'.! !

SymbolTableEntry subclass: #SymbolLocalVarEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

SymbolTableEntry subclass: #SymbolMethodEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/17/2011 13:12'!
genAssignCode

	(self offset = 0) ifTrue: [
		^ ' SM assignAt: ' ,  self index asString. 
	] ifFalse: [
		^ ' (SM  stackAt: ' , self offset asString , ') assignAt: ' , self index asString.
	]! !

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/24/2011 21:12'!
genReadCode

	(scope isGlobal) ifTrue:[
		^ ' (StackMachine globalStack at: ' ,  self index asString , ')'.
	] ifFalse: [
		(self offset = 0) ifTrue: [
			^ '(StackMachine at: ' ,  self index asString , ')'.
		] ifFalse: [
			^ '((StackMachine  stackAt: ' , self offset asString , ') at: ' , self index asString , ')'.
		]
	].! !

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/23/2011 16:52'!
genWriteCode

	(self offset = 0) ifTrue: [
		^ ' StackMachine at: ' ,  self index asString , ' put: '. 
	] ifFalse: [
		^ ' (StackMachine  stackAt: ' , self offset asString , ') at: ' , self index asString , ' put: '.
	]! !

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/4/2011 16:30'!
index

	^ scope indexOf: self.! !

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/6/2011 12:23'!
initialize

	super initialize.
	name := ''.
	scope := nil.
	bindingScope := nil.! !

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/6/2011 12:29'!
name

	^ name! !

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/2/2011 16:11'!
name: anObject

	name := anObject! !

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/6/2011 14:45'!
offset

	^ SymbolTable offsetFrom: scope.! !

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/6/2011 12:24'!
scope

	^ scope! !

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/6/2011 12:24'!
scope: anObject

	scope := anObject! !

Error subclass: #CompilerSymbolNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!CompilerSymbolNotFound methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/31/2011 13:57'!
description

	^ 'compiler symbol not found'! !

Error subclass: #VMSendException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!VMSendException methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2011 17:13'!
description

	^ 'message not found, during lookup'! !

Error subclass: #VMWrongNumberOfArgs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!VMWrongNumberOfArgs methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/29/2011 20:05'!
description

	^ 'blocked called with wrong number of args'! !
SymbolTable initialize!
StackMachine initialize!
ObjectRepresentation initialize!
